/*
 * Small Wide World
 * by Joel R. Voss aka. Javantea
 * Copyright 2007 AltSci Concepts
 * June 28, 2007
 *
 * Test program in C++.
 */

/*
Map maker
by Javantea
April 26, 2007
Ported to C++: June 28, 2007

*/

#include <cmath>
#include <iostream>
#include <fstream>
#include <sstream>
#include <stdlib.h>

using std::cout;
using std::cerr;
using std::endl;
using std::stringstream;

#include "sww.h"

Map createMapAB(int a_conns, int b_conns, int inter_conns, int seed_id=3211)
{
	srand(seed_id);
	Map a(NULL, "Test AB Map", 640, 480, 1);
	Points &p = a.points;
	int i;
	for(i = 0; i < a_conns + b_conns + 2; i++)
	{
		char name[] = "a";
		name[0] += i;
		p.push_back(Point(name, 320, 240));
	}
	// a is connected to b
	p[0].addConn(&(p[1]));
	for(i = 0; i < a_conns; i++)
	{
		p[0].addConn(&(p[i+2]));
	}
	for(i = 0; i < b_conns; i++)
	{
		p[1].addConn(&(p[i+2+a_conns]));
	}
	//#print b, addConn1, addConn2
	for(i = 0; i < 4000; i++)
	{
		a.randomize();
		a.sort1();
		//#a.sort1()
		//#a.sort1()
		//#a.sort1()
		//#a.sort1()
	}
	a.center();
	//#next i
	return a;
}
//#end void createMap([seed_id])

int main(int argc, char **argv)
{
	int i;
	for(i = 0; i < 6; i++)
	{
		int j;
		for(j = 0; j < 6; j++)
		{
			Map m = createMapAB(i, j, 0);
			string filename = "brute_" + itostr(i) + "_" + itostr(j) + "_a.svg";
			std::ofstream output(filename.c_str());
			output << m.str();
			output.close();
		}
	}
}
//#end void main()

//if __name__ == '__main__':
//	main()
//#end if
