"""
A human figure with SWW
by Javantea
Oct 12, 2009

The idea is to see whether SWW can map the human body in every possible 
configuration. It's similar to brute force.

It also makes a rather interesting file format..

"""

import mapmake1
from random import seed

def main():
	seeds = [23, 231, 2312]
	seed_id = 23126
	seed(seed_id)
	data = '''head - torso
torso - lshoulder
torso - rshoulder
lshoulder - lelbow
rshoulder - relbow
lelbow - lwrist
relbow - rwrist
lwrist - lfingers
rwrist - rfingers
torso - waist
waist - lhip
waist - rhip
lhip - lknee
rhip - rknee
lknee - lankle
rknee - rankle
lankle - ltoes
rankle - rtoes'''
	parts = set(data.split())
	parts.discard('-')
	
	names = list(parts)
	points = [mapmake1.Point(name) for name in names]
	
	conn_list = data.split('\n')
	for conn in conn_list:
		if ' - ' not in conn:
			continue
		#end if
		i_name, j_name = conn.split(' - ')
		i = names.index(i_name)
		j = names.index(j_name)
		points[i].addConn(points[j])
	#next conn
	
	passoc = {}
	for name in names:
		passoc[name] = points[names.index(name)]
	#next name
	
	passoc['head'].x = 50
	passoc['torso'].x = 50
	passoc['waist'].x = 50
	
	passoc['head'].y = 65
	passoc['torso'].y = 115
	passoc['waist'].y = 215
	
	passoc['rshoulder'].y = 115
	passoc['lshoulder'].y = 115
	passoc['lhip'].y = 215
	passoc['rhip'].y = 215
	
	passoc['rshoulder'].x = 75
	passoc['lshoulder'].x = 25
	passoc['lhip'].x = 25
	passoc['rhip'].x = 75
	
	passoc['relbow'].x = 75
	passoc['lelbow'].x = 25
	passoc['lknee'].x = 25
	passoc['rknee'].x = 75
	
	passoc['rwrist'].x = 75
	passoc['lwrist'].x = 25
	passoc['lankle'].x = 25
	passoc['rankle'].x = 75
	
	passoc['rfingers'].x = 75
	passoc['lfingers'].x = 25
	passoc['ltoes'].x = 25
	passoc['rtoes'].x = 75
	
	passoc['relbow'].y = 160
	passoc['lelbow'].y = 160
	passoc['lknee'].y = 260
	passoc['rknee'].y = 260
	
	passoc['rwrist'].y = 200
	passoc['lwrist'].y = 200
	passoc['lankle'].y = 300
	passoc['rankle'].y = 300
	
	passoc['rfingers'].y = 205
	passoc['lfingers'].y = 205
	passoc['ltoes'].y = 315
	passoc['rtoes'].y = 315
	
	width = 300
	height = 600
	m = mapmake1.Map(None, width, height, 1, '#9999ff')
	m.addPoints(points)
	
	w = 100
	h = 100
	m.randomize(50)
	for i in range(1):
		m.sort2((w + h) / 15)
		if i % 30 == 0:
			m.sort3()
		#end if
		if i % 32 == 0:
			m.sort4()
		#end if
		if i % 25 == 0:
			m.randomize(50)
		#end if
		#a.sort1()
		#a.sort1()
		#a.sort1()
		#a.sort1()
	#next i
	for i in range(25):
		m.sort4()
	#next i
	#m.sort3()
	
	m.center()
	
	print(m)
#end def main()




if __name__ == '__main__':
	main()
#end if
