#!/usr/bin/env python3
"""
myspacemap1.py
by Javantea
July 17, 2007

Maps friends on Myspace
"""
from __future__ import print_function
import urllib.request, urllib.error, urllib.parse
import re
from random import seed
import os
from time import sleep
from sys import path
path.append('.')
import mapmake1

# We use urlopen and file depending on protocol.
# http://www.dodgeball.com/user?uid=60145

class MyspaceMap(mapmake1.Map):
	def __init__(self, filename='data/mdmisgovernment.html', url='/mdmisgovernment', seed_id = 234, level=1, width=800, height=600):
		seed(seed_id)
		# Width, height, line_width = 1.
		mapmake1.Map.__init__(self, None, width, height, 1)
		self.p = []
		self.i = 0
		self.names = {}
		
		self.addFriend(filename, url, seed_id, level)
		self.organize()
	#def __init__(filename='dodge_jav1.html', seed_id = 234, levels=1)

	def addFriend(self, filename='data/mdmisgovernment.html', url='/mdmisgovernment', seed_id = 234, level=0):
		data = open(filename, 'r').read()
		
		found_user = re.finditer(r'\<span class=\"nametext\">([^\<]+)', data)
		
		# found finds all links...
		found = re.finditer(r'\<a href="([^"]+)"[^\>]*\>([^\<]+)', data)
		
		user = None
		friends = []
		
		for name in found_user:
			user = name.groups()
			break
		#next name
		
		if user == None:return
		
		for friend in found:
			friends.append(friend.groups())
		#next friend
		
		"""print 'user =', user
		print 'friends =', friends
		print 'friend of a friends =', foafs
		if more_foafs: print "+ more friends of a friend."
		"""
		
		local_p = []
		
		myurl = url
		if url[:5] != 'http:':
			if url[0] != '/': url = '/' + url
			myurl = "http://www.myspace.com" + url
		#end if
		
		# name = (name)
		if user[0] not in list(self.names.keys()):
			self.p.append(mapmake1.Point(user[0], url=myurl))
			self.names[user[0]] = self.i
			user_pt = self.i
			local_p.append(self.p[user_pt])
			self.i += 1
		else:
			user_pt = self.names[user[0]]
			#print [str(a) for a in self.p], self.names
			#print 'user', user[1], user_pt, 'is in names', self.p[user_pt]
		#end if
		
		# Max number of friends is 10
		friend_i = 0
		# friend = (url, name)
		for friend in friends:
			# if you remove this, you can get more urls, but there are _major_ 
			# issues if you don't replace url with: 
			#  'http://profile.myspace.com/' +
			#  d.replace('http://profile.myspace.com/', '')
			if friend[0][:74] != "http://profile.myspace.com/index.cfm?fuseaction=user.viewProfile&friendID=":
				# friends only
				continue
			#end if
			friend_i += 1
			if friend_i == 16: break
			# Only add them if they are new.
			if friend[1] not in list(self.names.keys()):
				self.p.append(mapmake1.Point(friend[1], url=friend[0]))
				self.names[friend[1]] = self.i
				local_p.append(self.p[self.i])
				self.i += 1
			#end if
			if level > 0:
				url = friend[0]
				b = re.search(r'friendID\=([0-9]+)', url)
				if b == None:
					print('u=', url)
					continue
				friend_filename = 'data/mysu_' + str(b.groups()[0]) + '.html'
				if not os.path.exists(friend_filename):
					print('<!-- Grabbing', url, '-->')
					# Need an absolute url.
					try:
						data = urllib.request.urlopen(url).read()
						open(friend_filename, 'wb').write(data)
					except urllib.error.URLError as e:
						print('Warning: Could not grab myspace friend', url, ':', e)
						#skip over adding this friend's friends.
						continue
					#end try
					# Don't hit them very hard.
					sleep(1.0)
				#end if
				self.addFriend(friend_filename, url, seed_id, level - 1)
			#end if
		#next friend
		
		# Max number of friends is 10
		friend_i = 0
		for friend in friends:
			if friend[0][:74] != "http://profile.myspace.com/index.cfm?fuseaction=user.viewProfile&friendID=":
				# friends only
				continue
			#end if
			friend_i += 1
			if friend_i == 16: break
			fid = self.names[friend[1]]
			self.p[user_pt].addConn(self.p[fid])
			#print 'conn', self.p[user_pt], 'to', self.p[fid]
		#next friend
		
		self.addPoints(local_p)
	#end def addFriend([filename], [seed_id], levels)
	
	def sort2(self, dist1 = 120, f = 0.5):
		# We can override sort2 to do dist1 = 170 instead of 70.
		mapmake1.Map.sort2(self, dist1, f)
	#end def sort2(self, dist1 = 70, f = 0.5)
	
	def organize(self):
		self.randomize(600)
		for i in range(30):
			self.sort2()
			if i % 20 == 0:
				self.sort3()
			#end if
			if i % 15 == 0:
				self.randomize(300)
			#end if
			#a.sort1()
			#a.sort1()
			#a.sort1()
			#a.sort1()
		#next i
		#m.sort3()
		self.center()
	#def organize()
	
	#def __str__(self):
	#	return str(self.m)
	#end def __str__()
#end class FriendMap

def main(seed_id = 2323):
	filename = 'data/mdmisgovernment.html'
	url = ''
	from sys import argv
	if len(argv) > 1:
		filename = argv[1]
	#end if
	# 1 level, 1000x1000.
	m = MyspaceMap(filename, url, seed_id, 1, 1000, 1000)
	print(m)
#end def main()

if __name__ == '__main__':
	main()
#end if
