#!/usr/bin/env python3
"""
myspacemap1.py
by Javantea
July 17, 2007

Maps friends on Myspace
"""
from __future__ import print_function
import urllib.request, urllib.error, urllib.parse
import re
from random import seed
import os
from time import sleep
from sys import path
path.append('.')
import mapmake1

# We use urlopen and file depending on protocol.
# http://www.dodgeball.com/user?uid=60145

import oauth.oauth as oauth
import urllib.request, urllib.parse, urllib.error

def MyspaceApiUrl(user_id, rtype='friends'):
	SERVER='api.myspace.com'
	PORT=80
	
	CONSUMER_KEY='http://www.small-wide-world.com/'
	CONSUMER_SECRET='13ede2daf8a14a8c9e87b6f346a49e92'
	
	consumer = oauth.OAuthConsumer(CONSUMER_KEY, CONSUMER_SECRET)
	
	signature_method_hmac_sha1 = oauth.OAuthSignatureMethod_HMAC_SHA1()
	
	rtypeu = ''
	if rtype == 'friends':
		rtypeu = '/friends'
	elif rtype == 'profile':
		rtypeu = '/profile'
	#end if
	url='http://api.myspace.com/v1/users/' + user_id + rtypeu + '.xml'
	
	oauth_request = oauth.OAuthRequest.from_consumer_and_token(consumer, http_url=url)
	oauth_request.set_parameter('oauth_token', '')
	oauth_request.sign_request(signature_method_hmac_sha1, consumer, None)
	
	#print oauth_request.parameters
	qs = urllib.parse.urlencode(oauth_request.parameters)
	url2 = 'http://api.myspace.com/v1/users/' + user_id + rtypeu + '.xml?' + qs

	return url2
#end def MyspaceApiUrl(user_id, rtype='friends')

class MyspaceMap(mapmake1.Map):
	def __init__(self, user_id='56603825', username='You', seed_id = 234, level=0, width=800, height=600):
		seed(seed_id)
		# Width, height, line_width = 1.
		mapmake1.Map.__init__(self, None, width, height, 1)
		self.p = []
		self.i = 0
		self.uids = {}
		self.names = {}
		
		self.addFriend(user_id, username, seed_id, level)
		self.organize()
	#def __init__(filename='dodge_jav1.html', seed_id = 234, levels=1)

	def addFriend(self, user_id='56603825', username='You', seed_id = 234, level=0):
		friend_filename = 'data/mysf_' + str(user_id) + '.xml'
		if not os.path.exists(friend_filename):
			url = MyspaceApiUrl(str(user_id), 'friends')
			print('<!-- Grabbing', url, '-->')
			# Need an absolute url.
			try:
				data = urllib.request.urlopen(url).read()
				open(friend_filename, 'wb').write(data)
			except urllib.error.URLError as e:
				print('Warning: Could not grab myspace friend', url, ':', e)
				#skip over adding this friend's friends.
				#continue
			#end try
			# Don't hit them very hard.
			sleep(1.0)
		#end if
		data = open(friend_filename, 'r').read()
		
		found_user = re.finditer(r'\<userid\>([^\<]+)', data)
		
		# found finds all links...
		found_name = re.finditer(r'\<displayname\>([^\<]+)', data)
		
		userid = None
		friendids = []
		friends = []
		
		for uid in found_user:
			if userid == None:
				userid = uid.groups()[0]
			else:
				friendids.append(uid.groups()[0])
			#end if
		#next img
		
		j = 0
		for friend in found_name:
			friendname = friend.groups()
			friends.append([friendids[j], friendname[0]])
			if friendids[j] not in self.names:
				self.names[friendids[j]] = friendname[0]
			#end if
			j += 1
		#next friend
		
		"""print 'user =', user
		print 'friends =', friends
		print 'friend of a friends =', foafs
		if more_foafs: print "+ more friends of a friend."
		"""
		
		local_p = []
		
		myurl = "http://www.myspace.com/" + userid[0]
		#if url[:5] != 'http:':
		#	myurl = "http://www.myspace.com" + url
		#end if
		
		# name = (name)
		if userid[0] not in list(self.uids.keys()):
			self.p.append(mapmake1.Point(username, url=myurl))
			self.uids[userid[0]] = self.i
			user_pt = self.i
			local_p.append(self.p[user_pt])
			self.i += 1
		else:
			user_pt = self.uids[userid[0]]
			#print [str(a) for a in self.p], self.names
			#print 'user', user[1], user_pt, 'is in names', self.p[user_pt]
		#end if
		
		# Max number of friends is 10
		friend_i = 0
		# friend = (url, name)
		for friend in friends:
			# if you remove this, you can get more urls, but there are _major_ 
			# issues if you don't replace url with: 
			#  'http://profile.myspace.com/' +
			#  d.replace('http://profile.myspace.com/', '')
			#if friend[0][:74] != "http://profile.myspace.com/index.cfm?fuseaction=user.viewprofile&friendid=":
			#	# friends only
			#	continue
			#end if
			friend_i += 1
			if friend_i == 16: break
			# Only add them if they are new.
			if friend[0] not in list(self.uids.keys()):
				self.p.append(mapmake1.Point(friend[1], url='http://profile.myspace.com/' + friend[0]))
				self.uids[friend[0]] = self.i
				local_p.append(self.p[self.i])
				self.i += 1
			#end if
			if level > 0:
				friendid = friend[0]
				self.addFriend(str(friendid), friend[1], seed_id, level - 1)
			#end if
		#next friend
		
		# Max number of friends is 10
		friend_i = 0
		for friend in friends:
			friend_i += 1
			if friend_i >= 16: break
			fid = self.uids[friend[0]]
			self.p[user_pt].addConn(self.p[fid])
			#print 'conn', self.p[user_pt], 'to', self.p[fid]
		#next friend
		
		self.addPoints(local_p)
	#end def addFriend([user_id], [username], [seed_id], levels)
	
	def sort2(self, dist1 = 170, f = 0.5):
		# We can override sort2 to do dist1 = 170 instead of 70.
		mapmake1.Map.sort2(self, dist1, f)
	#end def sort2(self, dist1 = 70, f = 0.5)
	
	def organize(self):
		self.randomize(600)
		for i in range(30):
			self.sort2()
			if i % 20 == 0:
				self.sort3()
			#end if
			if i % 15 == 0:
				self.randomize(300)
			#end if
			#a.sort1()
			#a.sort1()
			#a.sort1()
			#a.sort1()
		#next i
		#m.sort3()
		self.center()
	#def organize()
	
	#def __str__(self):
	#	return str(self.m)
	#end def __str__()
#end class FriendMap

def main(seed_id = 2323):
	from sys import argv
	if len(argv) > 1:
		filename = argv[1]
	#end if

	# The api only works for people who have installed the app, crud.
	#print MyspaceApiUrl('56603825', 'friends')
	#return
	
	# 1 level, 1000x1000.
	m = MyspaceMap('56603825', 'You', seed_id, 0, 1000, 1000)
	print(m)
#end def main()

if __name__ == '__main__':
	main()
#end if
