#!/usr/bin/env python3
"""
webmap1.py
by Javantea
July 17, 2007

Maps sites on the web
FIXME:
Use url for self.names to ensure.
"""
from __future__ import print_function
import urllib.request, urllib.error, urllib.parse
import re
from random import seed
import os
from time import sleep
from hashlib import sha
from sys import path
path.append('.')
import mapmake1

# We use urlopen and file depending on protocol.
# http://www.altsci.com/

class WebMap(mapmake1.Map):
	def __init__(self, url='http://www.altsci.com/', seed_id = 234, level=0):
		seed(seed_id)
		# Width, height, line_width = 1.
		mapmake1.Map.__init__(self, None, 500, 500, 1)
		self.p = []
		self.i = 0
		self.names = {}
		
		self.addFriend(filename, seed_id, level)
		self.organize()
	#def __init__(filename='dodge_jav1.html', seed_id = 234, levels=1)

	def addLink(self, url='http://www.altsci.com/', seed_id = 234, level=0):
		#data = open(filename, 'r').read()
		data = urllib.request.urlopen(url).read()
		
		found_user = re.finditer(r'\<title>([^\<]+)', data)
		
		# found finds all links...
		found = re.finditer(r'\<a href="([^"]+)"[^\>]*\>([^\<]+)', data)
		
		user = (url,)
		links = []
		
		for name in found_user:
			user = name.groups()
			break
		#next img
		
		for link in found:
			links.append(link.groups())
		#next friend
		
		"""print 'user =', user
		print 'friends =', friends
		print 'friend of a friends =', foafs
		if more_foafs: print "+ more friends of a friend."
		"""
		
		local_p = []
		
		# name = (name)
		if user[0] not in list(self.names.keys()):
			self.p.append(mapmake1.Point(user[0]))
			self.names[user[0]] = self.i
			user_pt = self.i
			local_p.append(self.p[user_pt])
			self.i += 1
		else:
			user_pt = self.names[user[0]]
			#print [str(a) for a in self.p], self.names
			#print 'user', user[1], user_pt, 'is in names', self.p[user_pt]
		#end if
		
		# Max number of friends is 10
		link_i = 0
		# friend = (url, name)
		for link in links:
			# if you remove this, you can get more urls, but there are _major_ 
			# issues if you don't replace url with: 
			#  'http://profile.myspace.com/' +
			#  d.replace('http://profile.myspace.com/', '')
			link_i += 1
			if link_i >= max_links: break
			# Only add them if they are new.
			if friend[1] not in list(self.names.keys()):
				self.p.append(mapmake1.Point(link[1]))
				self.names[link[1]] = self.i
				local_p.append(self.p[self.i])
				self.i += 1
			#end if
			if level > 0:
				url = link[0]
				link_filename = 'data/web_' + sha(url).hexdigest() + '.html'
				if not os.path.exists(link_filename):
					print('<!-- Grabbing', url, '-->')
					# Need an absolute url.
					try:
						data = urllib.request.urlopen(url).read()
						open(link_filename, 'wb').write(data)
					except urllib.error.URLError as e:
						print('Warning: Could not grab myspace friend', url, ':', e)
						#skip over adding this friend's friends.
						continue
					#end try
					# Don't hit them very hard.
					sleep(1.0)
				#end if
				self.addLink(link_filename, seed_id, level - 1)
			#end if
		#next friend
		
		# Max number of friends is 10
		link_i = 0
		for friend in friends:
			link_i += 1
			if link_i >= max_links: break
			fid = self.names[friend[1]]
			self.p[user_pt].addConn(self.p[fid])
			#print 'conn', self.p[user_pt], 'to', self.p[fid]
		#next friend
		
		self.addPoints(local_p)
	#end def addFriend([filename], [seed_id], levels)
	
	def sort2(self, dist1 = 170, f = 0.5):
		# We can override sort2 to do dist1 = 170 instead of 70.
		mapmake1.Map.sort2(self, dist1, f)
	#end def sort2(self, dist1 = 70, f = 0.5)
	
	def organize(self):
		self.randomize(600)
		for i in range(30):
			self.sort2()
			if i % 20 == 0:
				self.sort3()
			#end if
			if i % 15 == 0:
				self.randomize(300)
			#end if
			#a.sort1()
			#a.sort1()
			#a.sort1()
			#a.sort1()
		#next i
		#m.sort3()
		self.center()
	#def organize()
	
	#def __str__(self):
	#	return str(self.m)
	#end def __str__()
#end class FriendMap

def main(seed_id = 2323):
	url = 'http://www.altsci.com/'
	from sys import argv
	if len(argv) > 1:
		filename = argv[1]
	#end if
	m = WebMap(filename, seed_id, 1)
	print(m)
#end def main()

if __name__ == '__main__':
	main()
#end if
